/*
 * PopulationEA.hpp
 *
 *  Created on: Feb 22, 2015
 *      Author: Joost Huizinga
 */

#ifndef EA_POPULATION_HPP_
#define EA_POPULATION_HPP_

#include <fstream>
#include <iostream>
#include <vector>

template<typename Fit, typename ParentSelector, typename SurivorSelector>
class PopulationEA
{
public:
    typedef typename Fit::indiv_t indiv_t;

    PopulationEA(){
        //nix
    }

    /**
     * Initializes the population (parent) of the hill climber.
     *
     * This function should:
     * - assign the fitness and selector functions.
     * - initialize the population with copies of the initial individual
     * - randomize the population
     * - evaluate the population
     */
    void init(indiv_t initialIndividual,
            Fit fitnessFunction,
            ParentSelector parentSelector,
            SurivorSelector survivorSelector,
            size_t populationSize){
        /* TODO: YOUR CODE HERE */
    }

    /**
     * Runs one epoch (usually a generation) of the evolutionary algorithm.
     *
     * Implement this function such that:
     * - parents are selected using the parent selector
     *     -use the select(std::vector<indiv_t>& population) for parent selection
     *     -use the select(std::vector<indiv_t>& population, std::vector<indiv_t>& children) for survivor selection
     * - each parent produces one child that is a copy of himself
     * - the child is mutated and evaluated
     * - the new population is selected from the old population and the children
     */
    void epoch(){
        /* TODO: YOUR CODE HERE */

    }

    /**
     * Implement such that it returns the individual with the highest fitness of the population.
     *
     * Note: ties can be broken arbitrarily.
     */
    indiv_t &getBest(){
        /* TODO: YOUR CODE HERE */

    }

    /**
     * Returns the current population.
     */
    std::vector<indiv_t> &getPopulation(){
        return _population;
    }

private:
    std::vector<indiv_t> _population;
    Fit _fitnessFunction;
    ParentSelector _parentSelector;
    SurivorSelector _survivorSelector;

    /* TODO: YOUR CODE HERE IF YOU LIKE */

};



#endif /* EA_POPULATION_HPP_ */
